"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Keys = exports.DefaultWidth = void 0;
// Packages Imports
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
// Components Imports
var DigitCard_1 = __importDefault(require("./components/DigitCard"));
var Row_1 = __importDefault(require("./components/Row"));
var useTextManager_1 = __importDefault(require("./hooks/useTextManager"));
var DefaultValues_1 = require("./utils/DefaultValues");
// Default Render Function
function OTPKeyboard(props) {
    var _a = props.keys, keys = _a === void 0 ? DefaultValues_1.DEFAULT_KEYS : _a, _b = props.backspaceComponent, backspaceComponent = _b === void 0 ? null : _b, _c = props.submitComponent, submitComponent = _c === void 0 ? null : _c, keyboardStyle = props.keyboardStyle, _d = props.keyboardBackgroundColor, keyboardBackgroundColor = _d === void 0 ? DefaultValues_1.DEFAULT_KEYBOARD_COLOR : _d, digitBoxBackgroundColor = props.digitBoxBackgroundColor, digitColor = props.digitColor, _e = props.height, height = _e === void 0 ? DefaultValues_1.DEFAULT_KEYBOARD_HEIGHT : _e, _f = props.width, width = _f === void 0 ? DefaultValues_1.DEFAULT_KEYBOARD_WIDTH : _f, onPress = props.onPress, onSubmitPress = props.onSubmitPress, maxLength = props.maxLength, digitBoxStyle = props.digitBoxStyle;
    // Custom Hook to handle the text changes and callbacks
    var _g = useTextManager_1.default({
        maxLength: maxLength,
        onPress: onPress,
        onSubmitPress: onSubmitPress,
    }), onBackSpacePress = _g.onBackSpacePress, onKeyPress = _g.onKeyPress, onSubmit = _g.onSubmit;
    // Check if keys array is valid
    if (keys.length !== 10)
        return null;
    // Styles for the container
    var containerStyle = [
        { backgroundColor: keyboardBackgroundColor, height: height, width: width },
        keyboardStyle,
    ];
    // Render the keyboard
    return (react_1.default.createElement(react_native_1.View, { style: containerStyle },
        react_1.default.createElement(Row_1.default, null, keys.slice(0, 3).map(function (label, itemIndex) { return (react_1.default.createElement(DigitCard_1.default, __assign({ key: itemIndex, backgroundColor: digitBoxBackgroundColor, color: digitColor, onPress: function () { return onKeyPress(label.title); }, style: digitBoxStyle }, label))); })),
        react_1.default.createElement(Row_1.default, null, keys.slice(3, 6).map(function (label, itemIndex) { return (react_1.default.createElement(DigitCard_1.default, __assign({ key: itemIndex }, label, { backgroundColor: digitBoxBackgroundColor, color: digitColor, onPress: function () { return onKeyPress(label.title); }, style: digitBoxStyle }))); })),
        react_1.default.createElement(Row_1.default, null, keys.slice(6, 9).map(function (label, itemIndex) { return (react_1.default.createElement(DigitCard_1.default, __assign({ key: itemIndex }, label, { backgroundColor: digitBoxBackgroundColor, color: digitColor, onPress: function () { return onKeyPress(label.title); }, style: digitBoxStyle }))); })),
        react_1.default.createElement(Row_1.default, null,
            react_1.default.createElement(DigitCard_1.default, { customComponent: backspaceComponent, backgroundColor: digitBoxBackgroundColor, color: digitColor, onPress: onBackSpacePress, style: digitBoxStyle }),
            react_1.default.createElement(DigitCard_1.default, __assign({}, keys[9], { backgroundColor: digitBoxBackgroundColor, color: digitColor, onPress: function () { return onKeyPress(keys[9].title); }, style: digitBoxStyle })),
            react_1.default.createElement(DigitCard_1.default, { customComponent: submitComponent, backgroundColor: digitBoxBackgroundColor, color: digitColor, onPress: onSubmit, style: digitBoxStyle }))));
}
// Exports
exports.DefaultWidth = DefaultValues_1.DEFAULT_KEYBOARD_WIDTH;
exports.Keys = DefaultValues_1.DEFAULT_KEYS;
exports.default = OTPKeyboard;
//# sourceMappingURL=OTPKeyboard.js.map